using System.Collections.Generic;
using System;
using System.Text;

public class MethodBuilder {
  private string name;
  private string formalParameter;
  private StringBuilder srcBuilder;

  public MethodBuilder() {
    this.srcBuilder = new StringBuilder();
  }

  public void SetName(string name) {
    this.name = name;
  }
  public void SetFormalParameters(string formalParameter) {
    this.formalParameter = formalParameter;
  }

  public void BeginAlternatives() {
    srcBuilder.AppendLine("switch(curSy) { ");
  }

  public void StartAlternative()
  {
    srcBuilder.AppendLine();
  }

  public void EndAlternatives() {
    srcBuilder.AppendLine("} ");
  }

  public void AddSource(string src) {
    srcBuilder.AppendLine(src);
  }

  public void AddCall(string symbol, string actualParameter) {

    Console.WriteLine("Call: " + symbol + " " + actualParameter);
    srcBuilder.Append(symbol).Append("(").Append(actualParameter).Append(");");
  }

  public void Write() {
    Console.WriteLine(GetCode());
  }

  public string GetCode() {
    return "private void " + name + "(" + formalParameter + ") {" + Environment.NewLine +
           srcBuilder.ToString() + Environment.NewLine +
           "}";
  }
}
