using System.Collections.Generic;
using System;

public class SymbolBuilder {
  private static HashSet<string> symbols;
  
  private static Dictionary<string, string> formalParameter;
  private static Dictionary<string, string> init;
  private static Dictionary<string, string> mutate;
  private static Dictionary<string, string> code;
  
  public static void Initialize()
  {
    symbols = new HashSet<string>();
    formalParameter = new Dictionary<string, string>();
    init = new Dictionary<string, string>();
    mutate = new Dictionary<string, string>();
    code = new Dictionary<string, string>();
  }
  
  public static void CreateSymbol(string ident, string formalParameterList) {
    symbols.Add(ident);
    formalParameter[ident] = formalParameterList;
    init[ident] = "";
    mutate[ident] = "";
    code[ident] = "";
  }
  
  public static void DefineInitialization(string ident, string code) {
    init[ident] = code;
  }
  
  public static void DefineMutation(string ident, string code) {
    mutate[ident] = code;
  }
  
  public static void AddCode(string ident, string c) {
    code[ident] = c;
  }
  
  public static void WriteSymbols() {
    foreach(var s in symbols) {
      Console.WriteLine(s);
      Console.WriteLine(init[s]);
      Console.WriteLine(mutate[s]);
      Console.WriteLine(code[s]);
    }
  }
}
